VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "GetDIBBits"
   ClientHeight    =   3045
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4455
   LinkTopic       =   "Form1"
   ScaleHeight     =   3045
   ScaleWidth      =   4455
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton cmdConvert 
      Caption         =   "Create masks"
      Height          =   435
      Left            =   2520
      TabIndex        =   1
      Top             =   2340
      Width           =   1395
   End
   Begin VB.PictureBox picSource 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   0  'Kein
      Height          =   1440
      Left            =   360
      Picture         =   "frmMain.frx":0000
      ScaleHeight     =   96
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   240
      TabIndex        =   0
      Top             =   660
      Width           =   3600
   End
   Begin VB.Label lblWebsite 
      Alignment       =   1  'Rechts
      AutoSize        =   -1  'True
      Caption         =   "http://fox.acky.net"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00FF0000&
      Height          =   240
      Left            =   2700
      TabIndex        =   2
      Top             =   60
      Width           =   1695
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'Types
    Private Type tBitmapInfoHeader
        Size As Long
        W As Long
        H As Long
        Planes As Integer
        ColorDepth As Integer
        Compression As Long
        SizeImage As Long
        xPPM As Long
        yPPM As Long
        UsedColosr As Long
        ImportantColors As Long
    End Type
    
    Private Type tColorRGBA
        B As Byte
        G As Byte
        R As Byte
        A As Byte
    End Type
    
    Private Type tBitmap
        Type As Long
        W As Long
        H As Long
        WidthBytes As Long
        Planes As Integer
        ColorDepth As Integer
        Bits As Long
    End Type
    
    Private Type tBitmapInfo
        Header As tBitmapInfoHeader
        Colors As tColorRGBA
    End Type

'Declares
    Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal iDC As Long) As Long
    Private Declare Function DeleteDC Lib "gdi32" (ByVal iDC As Long) As Long
    
    Private Declare Function GetObjectAPI Lib "gdi32" Alias "GetObjectA" (ByVal Object As Long, ByVal Count As Long, Target As Any) As Long
    
    Private Declare Function GetDIBits Lib "gdi32" (ByVal iDC As Long, ByVal iBitmap As Long, ByVal iStartScan As Long, ByVal iNumScans As Long, iBits As Any, iBitmapInfo As tBitmapInfo, ByVal iUsage As Long) As Long
    Private Declare Function SetDIBits Lib "gdi32" (ByVal iDC As Long, ByVal iBitmap As Long, ByVal iStartScan As Long, ByVal iNumScans As Long, iBits As Any, iBitmapInfo As tBitmapInfo, ByVal iUsage As Long) As Long

Private Sub cmdConvert_Click()
    'Create mask
    ConvertMask picSource.hDC, picSource.Image.Handle
    
    'Update display
    picSource.Refresh
End Sub


Private Sub ConvertMask(ByVal iSourceDC As Long, ByVal iSourceHandle As Long)
    Dim A As Long
    Dim Temp As Long
    Dim Data() As tColorRGBA
    
    Dim TempBitmapInfo As tBitmapInfo
    Dim TempBitmap As tBitmap
    Dim TempDC As Long
    
    'Get DC and attach to target
    TempDC = CreateCompatibleDC(iSourceDC)
    GetObjectAPI iSourceHandle, Len(TempBitmap), TempBitmap
    
    'Setup bitmap info
    With TempBitmapInfo.Header
        'Internal setup
        .ColorDepth = TempBitmap.ColorDepth
        .Planes = TempBitmap.Planes
        .Size = 40
        
        'Get size
        .W = TempBitmap.W
        .H = TempBitmap.H
        
        'Create data buffer
        ReDim Data((.W * .H) - 1)
    End With
    
    'Get bitmap data (note that it's top-down)
    GetDIBits TempDC, iSourceHandle, 0, TempBitmap.H, Data(0), TempBitmapInfo, 0
    
    'Edit data
    For A = 0 To UBound(Data)
        With Data(A)
            'Check pixel color
            If .R = 255 And .G = 255 And .B = 255 Then
                'It was white -> set it to black
                .R = 0
                .G = 0
                .B = 0
            Else
                'It was not white, set it to white
                .R = 255
                .G = 255
                .B = 255
            End If
        End With
    Next
    
'    'Get position (7, 22)
'    Temp = (TempBitmap.H - 22) * TempBitmap.W + 7
'
'    'Set a blue pixel  there
'    Data(Temp).R = 0
'    Data(Temp).G = 0
'    Data(Temp).B = 255
    
    'Write data back
    SetDIBits iSourceDC, iSourceHandle, 0, TempBitmap.H, Data(0), TempBitmapInfo, 0
    
    'Release DC from target
    DeleteDC TempDC
End Sub

